# -*- coding: utf-8 -*-
# Elisa - Home multimedia server
# Copyright (C) 2006-2008 Fluendo Embedded S.L. (www.fluendo.com).
# All rights reserved.
#
# This file is available under one of two license agreements.
#
# This file is licensed under the GPL version 3.
# See "LICENSE.GPL" in the root of this distribution including a special
# exception to use Elisa with Fluendo's plugins.
#
# The GPL part of Elisa is also available under a commercial licensing
# agreement from Fluendo.
# See "LICENSE.Elisa" in the root directory of this distribution package
# for details on that license.

"""
Utility functions for sorting
"""

__maintainer__ = 'Florian Boucault <florian@fluendo.com>'


import re

natural_re = re.compile('(\d+|\D+)')

def _try_int(s):
    try:
        return int(s)
    except ValueError:
        return s

def _natural_key(s):
    return [_try_int(i) for i in natural_re.findall(s.lower())]

def natural_sort(l):
    """
    Case insensitive human compliant sort.

    @param l: list that needs to be sorted
    @type l:  list of string
    """
    l.sort(key=_natural_key)

