# -*- coding: utf-8 -*-
# Elisa - Home multimedia server
# Copyright (C) 2006-2008 Fluendo Embedded S.L. (www.fluendo.com).
# All rights reserved.
#
# This file is available under one of two license agreements.
#
# This file is licensed under the GPL version 3.
# See "LICENSE.GPL" in the root of this distribution including a special
# exception to use Elisa with Fluendo's plugins.
#
# The GPL part of Elisa is also available under a commercial licensing
# agreement from Fluendo.
# See "LICENSE.Elisa" in the root directory of this distribution package
# for details on that license.


__maintainer__ = 'Lionel Martin <lionel@fluendo.com>'

from elisa.base_components.action import Action
from elisa.core import plugin_registry
from elisa.core import player


class ShowPlayerAction(Action):
    """
    Hide the menu and show the current player (player or slideshow)
    """

    # FIXME: what is it used for ?
    label='show player'
    supported_file_types=()
    
    elisa_model = None
    play_when_visible = False
    player_model = None


    def __call__(self, controller, origin):
        """
        @raise TypeError: When action has incorrect parameters
        """
        ElisaModelClass = plugin_registry.get_component_class('base:elisa_model')
        PlayerModelClass = plugin_registry.get_component_class('base:player_model')
        if isinstance(self.elisa_model, ElisaModelClass):
            self.elisa_model.menu_visible = False
            if self.play_when_visible == True and isinstance(self.player_model, PlayerModelClass):
                self.player_model.state = player.STATES.PLAYING
                
        else:
            raise TypeError("action %s have incorrect parameters" % self.name)
