# -*- coding: utf-8 -*-
# Elisa - Home multimedia server
# Copyright (C) 2006-2008 Fluendo Embedded S.L. (www.fluendo.com).
# All rights reserved.
#
# This file is available under one of two license agreements.
#
# This file is licensed under the GPL version 3.
# See "LICENSE.GPL" in the root of this distribution including a special
# exception to use Elisa with Fluendo's plugins.
#
# The GPL part of Elisa is also available under a commercial licensing
# agreement from Fluendo.
# See "LICENSE.Elisa" in the root directory of this distribution package
# for details on that license.

__maintainer__ = 'Benjamin Kampmann <benjamin@fluendo.com>'

from elisa.base_components.action import Action
from elisa.core import player
from elisa.core import plugin_registry


class ViewimageAction(Action):
    
    def __init__(self):
        self.parent_model = None
        self.uri = None
        self.slideshow_model = None

    def __call__(self, controller, origin):

        self.debug("Clean the slideshow_model playlist")
        uri = self.uri

        parent = self.parent_model()
        if not parent:
            return

        if not uri in self.slideshow_model.playlist:
            self.slideshow_model.playlist[:] = []
            for new_uri in [child.uri for child in parent.children]:
                self.slideshow_model.playlist.append(new_uri)


        index = self.slideshow_model.playlist.index(uri)
        self.slideshow_model.current_index = index
        self.slideshow_model.preview_mode = False
        self.slideshow_model.playing = False
